Package org.apache.sysds.runtime.instructions.ooc

# Interface OOCStreamable<T>

All Known Subinterfaces:
  `OOCStream<T>`

All Known Implementing Classes:
  `CachingStream`, `FilteredOOCStream`, `MergedOOCStream`, `PlaybackStream`, `SourceOOCStream`, `SourceOOCStreamable`, `SplittingOOCStream`, `SubOOCStream`, `SubscribableTaskQueue`

public interface OOCStreamable<T>

## Method Summary

Modifier and Type
Method
Description
`void`
`addDownstreamMessageRelay(Consumer<OOCStreamMessage> relay)`
`void`
`addUpstreamMessageRelay(Consumer<OOCStreamMessage> relay)`
`void`
`clearDownstreamMessageRelays()`
`void`
`clearUpstreamMessageRelays()`
`CacheableData<?>`
`getData()`
`DataCharacteristics`
`getDataCharacteristics()`
`OOCStream<T>`
`getReadStream()`
`CachingStream`
`getStreamCache()`
`OOCStream<T>`
`getWriteStream()`
`boolean`
`hasStreamCache()`
`boolean`
`isProcessed()`
`void`
`messageDownstream(OOCStreamMessage msg)`
`void`
`messageUpstream(OOCStreamMessage msg)`
`void`
`setData(CacheableData<?> data)`
`void`
`setDownstreamMessageRelay(Consumer<OOCStreamMessage> relay)`
`void`
`setIXTransform(BiFunction<Boolean,IndexRange,IndexRange> transform)`
`void`
`setUpstreamMessageRelay(Consumer<OOCStreamMessage> relay)`

## Method Details

### getReadStream

OOCStream<T> getReadStream()

### getWriteStream

OOCStream<T> getWriteStream()

### hasStreamCache

boolean hasStreamCache()

### getStreamCache

CachingStream getStreamCache()

### isProcessed

boolean isProcessed()

### getDataCharacteristics

DataCharacteristics getDataCharacteristics()

### getData

CacheableData<?> getData()

### setData

void setData(CacheableData<?> data)

### messageUpstream

void messageUpstream(OOCStreamMessage msg)

### messageDownstream

void messageDownstream(OOCStreamMessage msg)

### setUpstreamMessageRelay

void setUpstreamMessageRelay(Consumer<OOCStreamMessage> relay)

### setDownstreamMessageRelay

void setDownstreamMessageRelay(Consumer<OOCStreamMessage> relay)

### addUpstreamMessageRelay

void addUpstreamMessageRelay(Consumer<OOCStreamMessage> relay)

### addDownstreamMessageRelay

void addDownstreamMessageRelay(Consumer<OOCStreamMessage> relay)

### clearUpstreamMessageRelays

void clearUpstreamMessageRelays()

### clearDownstreamMessageRelays

void clearDownstreamMessageRelays()

### setIXTransform

void setIXTransform(BiFunction<Boolean,IndexRange,IndexRange> transform)